{-# LANGUAGE DataKinds #-}
{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE TypeOperators #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE TemplateHaskell #-}

module ISIDORE.Client where

import Servant.API
import Servant.Client

import Data.Proxy(Proxy(..))
import Data.ByteString.Lazy (ByteString)
import qualified Data.Text as T

data Output = JSON

instance ToHttpApiData Output where
  toUrlPiece JSON = "json"

type ISIDOREAPI = Search

-- search?q=colza&output=json&replies=1&author=jm&
type Search = "search"
  :> QueryParam "output" Output
  :> QueryParam "q" T.Text
  :> QueryParam "author" T.Text
  :> Get '[JSON] T.Text

isidoreAPI :: Proxy ISIDOREAPI
isidoreAPI = Proxy

search :: Maybe Output -> Maybe T.Text -> Maybe T.Text -> ClientM T.Text

search = client isidoreAPI
